if service.getEditText() then
  dictAr()
 else
  local luajava = require("luajava")
  local SpeechRecognizer = luajava.bindClass("android.speech.SpeechRecognizer")
  local Intent = luajava.bindClass("android.content.Intent")
  local RecognizerIntent = luajava.bindClass("android.speech.RecognizerIntent")
  local Looper = luajava.bindClass("android.os.Looper")
  local Handler = luajava.bindClass("android.os.Handler")
  local activity = this
  local handler = Handler(Looper.getMainLooper())
  local vibrator = activity.getSystemService("vibrator")
  local recognizer = SpeechRecognizer.createSpeechRecognizer(activity)

  local function startVoiceRecognition(activity)
    local intent = Intent(RecognizerIntent.ACTION_RECOGNIZE_SPEECH)
    intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE_MODEL, RecognizerIntent.LANGUAGE_MODEL_FREE_FORM)
    intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE, "ar")

    handler.postDelayed(function()
      vibrator.vibrate(50)
    end, 350)

    local recognitionListener = luajava.createProxy("android.speech.RecognitionListener", {
      onResults = function(params)
        local results = params.getStringArrayList(SpeechRecognizer.RESULTS_RECOGNITION)
        local text = results.get(0)

        if text and text ~= "" then

          if text:lower() == "توقف" then
            this.postSpeak(200,"تم إيقافُ البحث. ")
            return
           elseif text:lower() == "تحديث المفتاح" then
            updateApiKey()
            return
           elseif text:lower() == "المساعد السريع" then this.postSpeak(200,"اِطْرَحْ سُؤَالَكَ الْآنْ. يُمْكِنُكَ فِي كُلِّ مَرَّةٍ طَرْحُ سُؤَالٍ مُسْتَقِل.")
            local function checkSpeakingStatus()
              if not service.isSpeaking() then
                quickAssist()
               else
                handler.postDelayed(checkSpeakingStatus, 1000) -- إعادة التحقق بعد ثانية
              end
            end
            handler.postDelayed(checkSpeakingStatus, 1500) -- بدء التحقق بعد 1.5 ثانية
            return
           elseif text == "الاملاء" then
            dictAr()
            return

           elseif text == "البث المباشر" then
            if service.click({{"إنشاء منشور على فيسبوك|Make a post on Facebook|Créer une publication sur Facebook","فيديو بث مباشر|Live video|Vidéo en direct>50","بث مباشر|Go Live|Lancer un direct>90",}})
             elseif service.click({{"بث مباشر|En direct|Live","بث مباشر|Go Live|Lancer un direct>90",}})
            end
            return
           elseif text == "منشور جديد" then
            if service.click({{"إنشاء منشور على فيسبوك|Make a post on Facebook|Créer une publication sur Facebook","<Quoi de neuf*|What's on your mind*|بم تفكر*>30",}})
             elseif service.click({{"Quoi de neuf*|What's on your mind*|بم تفكر*","<Quoi de neuf*|What's on your mind*|بم تفكر*>10",}})
            end
            return
           elseif text == "نشر الوسائط" then
service.click({{"تحديد صور أو مقاطع فيديو لاستخدامها في منشورك|Select photos or videos for your post|Sélectionnez des photos ou des vidéos pour votre publication",}})
            return
           elseif text == "قصه جديده" then
            service.click({{"إنشاء قصة|Create story|Créer une story",}})
            return
elseif text == "تصوير" then
require 'import' import "android.content.*" i= Intent() .setComponent(ComponentName("com.facebook.katana", "com.facebook.inspiration.shortcut.cameralauncher.InspirationCameraExternalLaunchActivity")) this.startActivity(i)
return

           elseif text == "الملف الشخصي" then
            service.click({{"انتقال إلى الملف الشخصي|Go to profile|Accéder au profil",}})
            return

           elseif text == "منشورات الاصدقاء" then
            service.click({{"*المواجز*|*Feeds*|*Fils*", "*علامة تبويب الأصدقاء*|*Onglet Amis*|*Friends tab*>10$1500", "%Glisser l'écran vers le bas",}})
            return
           elseif text == "منشورات الصفحات" then
            service.click({{"*المواجز*|*Feeds*|*Fils*", "*الصفحات*|*Pages*>10$1500", "%Glisser l'écran vers le bas",}})
            return
           elseif text:lower() == "منشورات المجموعات" then
            service.click({{"*المواجز*|*Feeds*|*Fils*", "*المجموعات*|*Groupes*|*Groups*>10$1500","%Glisser l'écran vers le bas",}})
            return
           elseif text:lower() == "المنشورات المفضله" then
            service.click({{"*المواجز*|*Feeds*|*Fils*", "*المفضلة*|*Favorites*>10$1500", "%Glisser l'écran vers le bas",}})
            return






                      elseif text:lower() == "المساعده العامه" then
            dofile(dir.. "help.lua")
            return
           elseif text:lower() == "المساعده" then

            local helpText = [[
توقف  
تحديث المفتاح
المساعد السريع
المساعد السريع  
الإملاء  
البث المباشر  
منشور جديد  
نشر الوسائط  
قصة جديدة  
تصوير  
الملف الشخصي  
منشورات الأصدقاء  
منشورات الصفحات  
منشورات المجموعات  
المنشورات المفضلة  
المساعدة
المساعَدة العامة.
            ]]
            for line in helpText:gmatch("[^\r\n]+") do
              print(line)
            end
            return

           else
            this.postSpeak(200, "لا توجد خدمة متطابقة.")
          end
        end
      end,
      onError = function(error)
        this.postSpeak(200, "لم يتم التقاط أي نص.")
      end,
    })

    recognizer.setRecognitionListener(recognitionListener)
    recognizer.startListening(intent)
  end

  service.speak("Facebook ")
  local function checkSpeakingStatus()
    if not service.isSpeaking() then
      startVoiceRecognition(activity)
     else
      handler.postDelayed(checkSpeakingStatus, 500)
    end
  end
  handler.postDelayed(checkSpeakingStatus, 500)
end