if service.getEditText() then
  dictAr()
 else
  local luajava = require("luajava")
  local SpeechRecognizer = luajava.bindClass("android.speech.SpeechRecognizer")
  local Intent = luajava.bindClass("android.content.Intent")
  local RecognizerIntent = luajava.bindClass("android.speech.RecognizerIntent")
  local Looper = luajava.bindClass("android.os.Looper")
  local Handler = luajava.bindClass("android.os.Handler")
  local activity = this
  local handler = Handler(Looper.getMainLooper())
  local vibrator = activity.getSystemService("vibrator")
  local recognizer = SpeechRecognizer.createSpeechRecognizer(activity)

  local function startVoiceRecognition(activity)
    local intent = Intent(RecognizerIntent.ACTION_RECOGNIZE_SPEECH)
    intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE_MODEL, RecognizerIntent.LANGUAGE_MODEL_FREE_FORM)
    intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE, "ar")

    handler.postDelayed(function()
      vibrator.vibrate(50)
    end, 350)

    local recognitionListener = luajava.createProxy("android.speech.RecognitionListener", {
      onResults = function(params)
        local results = params.getStringArrayList(SpeechRecognizer.RESULTS_RECOGNITION)
        local text = results.get(0)

        if text and text ~= "" then
          if text:lower() == "توقف" then
            this.postSpeak(200, "تم إيقافُ البحث.")
            return
           elseif text:lower() == "تحديث المفتاح" then
            updateApiKey()
            return
           elseif text:lower() == "المساعد السريع" then
            this.postSpeak(200, "اِطْرَحْ سُؤَالَكَ الْآنْ. يُمْكِنُكَ فِي كُلِّ مَرَّةٍ طَرْحُ سُؤَالٍ مُسْتَقِل.")
            local function checkSpeakingStatus()
              if not service.isSpeaking() then
                quickAssist()
               else
                handler.postDelayed(checkSpeakingStatus, 1000)
              end
            end
            handler.postDelayed(checkSpeakingStatus, 1500)
            return
           elseif text == "الاملاء" then
            dictAr()
            return
           elseif text == "حذف البيانات" then
            require 'import'
            import "android.content.*"
            local i = Intent().setComponent(ComponentName("org.telegram.messenger", "org.telegram.ui.ExternalActionActivity"))
            this.startActivity(i)
            service.click({{"مسح الذاكرة المؤقتة*|Clear Cache*|Effacer le cache*>50", "مسح الذاكرة المؤقتة*|Clear Cache*|Effacer le cache*>50", "%Retour",
            }})
            return
           elseif text == "المكالمه الاخيره" then
            service.click({{"Ouvrir le menu de navigation|فتح قائمة التنقل|Open navigation menu$100","<Appels|Calls|المكالمات>5$100","%clique direct$100", "<Appel audio|Call|اتصال#1>15","%éléments précédents",}})
            return
elseif text == "الاتصال بالمكالمه الاخيره" then
service.click({{"Ouvrir le menu de navigation|فتح قائمة التنقل|Open navigation menu$100","<Appels|Calls|المكالمات>5$100","%clique direct$100", "Appel audio|Call|اتصال#1>15",}})
            return
           elseif text == "البحث" then
            service.click({{"بحث|Rechercher|Search", }})
task(1600, function() dictAr() end)
            return
           elseif text == "" then
            service.click({{}})
            return
           elseif text == "" then
            service.click({{}})
            return
           elseif text == "" then
            service.click({{}})
            return

           elseif text == "" then
            service.click({{}})
            return

           elseif text == "" then
            service.click({{}})
            return
           elseif text == "" then
            service.click({{}})
            return
           elseif text == "" then
            service.click({{}})
            return
           elseif text == "" then
            service.click({{}})
            return
                      elseif text:lower() == "المساعده العامه" then
            dofile(dir.. "help.lua")
            return
           elseif text:lower() == "المساعده" then

            local helpText = [[
توقف  
تحديث المفتاح
المساعد السريع
الإملاء  
حذف البيانات  
المكالمة الأخيرة  
الاتصال بالمكالمة الأخيرة  
البحث  
المساعدة
المساعَدة العامة.
            ]]
            for line in helpText:gmatch("[^\r\n]+") do
              print(line)
            end
            return
           else
            this.postSpeak(200, "لا توجد خدمة متطابقة.")
          end
        end
      end,

      onError = function(error)
        this.postSpeak(200, "لم يتم التقاط أي نص.")
      end,
    })

    recognizer.setRecognitionListener(recognitionListener)
    recognizer.startListening(intent)
  end

  service.speak("telegram ")
  local function checkSpeakingStatus()
    if not service.isSpeaking() then
      startVoiceRecognition(activity)
     else
      handler.postDelayed(checkSpeakingStatus, 500)
    end
  end
  handler.postDelayed(checkSpeakingStatus, 500)
end